#!/bin/bash
#
LIM3ORE=3300 # 3300 limite su 3 ore pari a 3kw + 10%
LIM2MIN=4191 # 4191 limite 2minuti pari 3.3kw + 27%
FILEPOWER=/run/shm/power
FILEPOWERHI=/run/shm/pow_hi
FILEENERGYHI=/run/shm/ene_hi
POW=0
IP1=`cat /run/shm/123s_LIVEMEMORY.json | cut -d, -f16 | cut -d: -f2`
CP1=`cat /run/shm/metern2.txt | grep '*W)'`
CP2=`echo $CP1 | cut -d'(' -f2 | cut -d* -f1`
POW=`echo "$CP2 - $IP1" | bc`
# potenza nell'istante di lettura
POW1=${POW/.*} 

CE1=`cat /run/shm/metern2.txt | grep '*Wh)'`
CE2=`echo $CE1 | cut -d'(' -f2 | cut -d* -f1`
CEOLD=`cat $FILEENERGYHI`
POE=`echo "($CE2 -$CEOLD)*60 - $IP1" | bc`
# potenza media in un minuto
POE1=${POE/.*}
# prendo il maggiore tra i due dati
if [ $POE1 -gt  $POW1 ]; then 
    $POW1=$POE1
fi
# il minimo è zero per non avere valori negativi
if [ $POW1 -lt  0 ]; then 
    POW1=0
fi
# inserisco l'ultimo dato e cancello il piu' vecchio
echo $POW1 >> $FILEPOWER
NDATA=`wc -l < $FILEPOWER`
if [ $NDATA -gt 180 ]; then
    sed -i '1d' $FILEPOWER
fi
#
# parte potenza assorbita oltre i limiti
#
PLAST=`cat $FILEPOWERHI`
if [ $PLAST -gt  $LIM2MIN ] && [ $POW1 -gt  $LIM2MIN ]; then
# comandi da eseguire in caso di assorbimento istantaneo oltre soglia
    /var/www/comapps/telegram.sh "Allarme Distacco Contatore picco potenza $POW1 W" 
fi
PMED=`awk '{s+=$1} END {if(NR>0) print s/NR}' $FILEPOWER | cut -d. -f1`
if [ $PMED -gt $LIM3ORE ]; then 
# comandi da eseguire in caso di assorbimento prolungato oltre il 10% 
    /var/www/comapps/telegram.sh "Allarme Distacco Contatore media ultime 3 ore $PMED W" 
fi
echo $POW1 > $FILEPOWERHI
echo $CE2 > $FILEENERGYHI
#
